=begin
TIG (c) 2011
Usage: Plugins menu > 'Click Back of Face to Flip...'
Click on a face.
If you click on its back the face flips [reverses].
If you click on its front it's unchanged.
<Esc> or Choose another tool to stop this tool...
If you want it to 'beep' when a face is flipped then set @@BEEP=true at 
the start of the code...
Donations:
PayPal.com info @ revitrev.org
Version:
1.0 20110928 First issue.
=end
require 'sketchup.rb'
module TIG
class TIG::Click2flip
  @@BEEP=false
  def initialize()
    @ip  = nil
    @ip1 = nil
  end
  def activate()
    @ip  = Sketchup::InputPoint.new
    @ip1 = Sketchup::InputPoint.new
    @msg="Click back of face to flip it..."
    self.reset()
  end
  def deactivate(view)
    view.invalidate
  end
  def onCancel(flag, view)
    view.invalidate
    Sketchup.send_action("selectSelectionTool:")
    return nil
  end
  def resume(view)
    Sketchup::set_status_text(@msg, SB_PROMPT)
  end
  def reset()
    Sketchup::set_status_text(@msg, SB_PROMPT)
  end
  def onMouseMove(flags, x, y, view)
    @ip.pick(view, x, y)
    if @ip != @ip1
        view.invalidate if @ip.display? or @ip1.display?
        @ip1.copy!(@ip)
        view.tooltip = @ip1.tooltip
    end
  end
  def onLButtonDown(flags, x, y, view)
    if @ip1.valid?
        @pt=@ip1.position
        ph = view.pick_helper
        ph.do_pick(x,y)
        @face = ph.picked_face
        self.flipper() if @face
    end
  end
  def flipper()
    normal=@face.normal
    vector=@pt.vector_to(Sketchup.active_model.active_view.camera.eye)
    angle=normal.angle_between(vector)
    if angle > 90.degrees
      @face.reverse!
      UI.beep if @@BEEP
    end#if
  end
end#class
UI.menu('Plugins').add_item('Click Back of Face to Flip...'){Sketchup.active_model.select_tool(TIG::Click2flip.new())} unless file_loaded?(__FILE__)
file_loaded(__FILE__)
end#module
